=== debian/changelog ===
zxc (0.7.3+ds-2) unstable; urgency=medium

  * d/control: fix section for bin:zxc. (Closes: #1129261)

 -- Alex Myczko <tar@debian.org>  Sun, 01 Mar 2026 11:00:56 +0000

zxc (0.7.3+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1127400)

 -- Alex Myczko <tar@debian.org>  Fri, 27 Feb 2026 16:17:10 +0000
