=== debian/control ===
Source: zxc
Section: libs
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.7.3
Homepage: https://github.com/hellobertrand/zxc
Vcs-Browser: https://salsa.debian.org/debian/zxc
Vcs-Git: https://salsa.debian.org/debian/zxc.git

Package: libzxc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libzxc0 (= ${binary:Version}),
 ${misc:Depends},
Description: High-performance asymmetric lossless compression library - header files
 This is a high-performance, lossless, asymmetric compression library
 optimized for Content Delivery and Embedded Systems (Game Assets,
 Firmware, App Bundles). It is designed to be "Write Once, Read Many.".
 Unlike codecs like LZ4, ZXC trades compression speed (build-time) for
 maximum decompression throughput (run-time).

Package: libzxc0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: High-performance asymmetric lossless compression library
 This is a high-performance, lossless, asymmetric compression library
 optimized for Content Delivery and Embedded Systems (Game Assets,
 Firmware, App Bundles). It is designed to be "Write Once, Read Many.".
 Unlike codecs like LZ4, ZXC trades compression speed (build-time) for
 maximum decompression throughput (run-time).
 .
 This is the library.

Package: zxc
Section: utils
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libzxc0 (= ${binary:Version})
Description: High-performance asymmetric lossless compression binary
 This is a high-performance, lossless, asymmetric compression library
 optimized for Content Delivery and Embedded Systems (Game Assets,
 Firmware, App Bundles). It is designed to be "Write Once, Read Many.".
 Unlike codecs like LZ4, ZXC trades compression speed (build-time) for
 maximum decompression throughput (run-time).
 .
 This is the binary.
