## zxc 0.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -155,11 +155,17 @@
     ${ZXC_VARIANT_OBJECTS}
 )
 
+# =============================================================================
+# ABI Versioning (Debian/Linux shared libraries)
+# =============================================================================
+# Increment this number ONLY when breaking the ABI. 
+set(ZXC_SOVERSION 1)
+
 # Set library output name and version
 set_target_properties(zxc_lib PROPERTIES
     OUTPUT_NAME zxc
     VERSION ${PROJECT_VERSION}
-    SOVERSION ${MAJOR_VER}
+    SOVERSION ${ZXC_SOVERSION}
 )
 
 # Target-based include directories for the main lib
@@ -290,9 +296,3 @@
             target_compile_options(zxc PRIVATE -flto)
             target_link_options(zxc PRIVATE -flto)
         endif()
-    endif()
-    
-    # Profile-Guided Optimization for CLI
-    if(NOT MSVC)
-        if(ZXC_PGO_MODE STREQUAL "GENERATE")
-            target_compile_options(zxc PRIVATE -fprofile-generate=${CMAKE_BINARY_DIR}/pgo)
