=== debian/changelog ===
zxc (0.8.1-1) unstable; urgency=medium

  * New upstream version.
  * d/control: bump version.

 -- Alex Myczko <tar@debian.org>  Mon, 02 Mar 2026 21:19:45 +0000
