=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libzxc0 (= ${binary:Version}),
+ libzxc1 (= ${binary:Version}),
  ${misc:Depends},
 Description: High-performance asymmetric lossless compression library - header files
  This is a high-performance, lossless, asymmetric compression library
@@ -25,7 +25,7 @@
  Unlike codecs like LZ4, ZXC trades compression speed (build-time) for
  maximum decompression throughput (run-time).
 
-Package: libzxc0
+Package: libzxc1
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -46,7 +46,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- libzxc0 (= ${binary:Version})
+ libzxc1 (= ${binary:Version})
 Description: High-performance asymmetric lossless compression binary
  This is a high-performance, lossless, asymmetric compression library
  optimized for Content Delivery and Embedded Systems (Game Assets,
